Package: catregs
Type: Package
Title: Post-Estimation Functions for Generalized Linear Mixed Models
Version: 1.3
Authors@R: c(person("David", "Melamed", role = c("aut", "cre"), email = "dmmelamed@gmail.com", comment = c(ORCID = "0000-0002-8821-7698")))
Description: Several functions for working with mixed effects regression models for limited dependent variables. The functions facilitate post-estimation of model predictions or margins, and comparisons between model predictions for assessing or probing moderation. Additional helper functions facilitate model comparisons and implements simulation-based inference for model predictions of alternative-specific outcome models. See also, Melamed and Doan (2024, ISBN: 978-1032509518). 
Depends: R (>= 3.5.0)
License: GPL-2 | GPL-3
Encoding: UTF-8
LazyData: true
Imports: methods
Suggests: tidyverse, ggplot2, MASS, emmeans, pscl, nnet,
        marginaleffects, ggpubr, knitr, rmarkdown, Epi, dplyr, ordinal,
        nlme, lme4
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-12-18 22:56:42 UTC; melamed.9
Author: David Melamed [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8821-7698>)
Maintainer: David Melamed <dmmelamed@gmail.com>
Repository: CRAN
Date/Publication: 2025-12-18 23:10:02 UTC
Built: R 4.6.0; ; 2026-04-26 13:59:22 UTC; unix

exportPattern("^[[:alpha:]]+")
    importFrom("stats", "AIC", "BIC", "as.formula", "coef", "dnbinom",
               "dnorm", "dpois", "family", "formula", "glm",
               "influence.measures", "lm", "logLik", "na.omit", "pchisq",
               "plogis", "predict", "qnorm", "residuals", "residuals.glm",
               "rnorm", "sd", "var", "vcov")
    importFrom("utils", "data")
    importFrom("methods", "is")

## -----------------------------------------------------------------------------
library(catregs)
data("LF06art")
p1 <- glm(art ~ fem + mar + kid5 + phd + ment , family = "poisson", data = LF06art)
table(LF06art$art)
fit<-count.fit(p1,0:19)
names(fit)
#fit$ic
#fit$pic
#fit$models
#fit$models.pic

## -----------------------------------------------------------------------------
library(catregs)
data("essUK")
m1 <- glm(safe ~ religious + minority*female + age,data=essUK,family="binomial")
des<-margins.des(m1,expand.grid(minority=c(0,1),female=c(0,1)))
des
ma1 <- suppressWarnings(as.data.frame(marginaleffects::avg_slopes(m1,
                                                                         variables="female",newdata=marginaleffects::datagrid(minority=0,
                                                                                                                              religious=3.6024,age=53.146))))
ma2 <- suppressWarnings(as.data.frame(marginaleffects::avg_slopes(m1,
                                                                  variables="female",newdata=marginaleffects::datagrid(minority=1,
                                                                                                                       religious=3.6024,age=53.146))))
cames <- rbind(ma2,ma1)
compare.margins(margins=cames$estimate,margins.ses=cames$std.error)

## -----------------------------------------------------------------------------
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
des2<-margins.des(m1,expand.grid(woman=c(0,1),parrole=c(0,1)))
des2
first.diff.fitted(m1,des2,compare=c(4,2)) # Pr(Drink | Mothers) - Pr(Drink | Childless Women)
first.diff.fitted(m1,des2,compare=c(3,1)) # Pr(Drink | Fathers) - Pr(Drink | Childless Men)

## -----------------------------------------------------------------------------
library(catregs)
library(Epi)
data("LF06travel")
m1 <- clogistic(choice ~ train + bus + time  + invc, strata=id, data=LF06travel)
design <- data.frame(train=c(0,0,1),bus=c(0,1,0),time=200,invc=20)
design
margins.dat.clogit(m1,design)

## -----------------------------------------------------------------------------
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
des2<-margins.des(m1,expand.grid(woman=c(0,1),parrole=c(0,1)))
margins.dat(m1,des2,rounded=5)
des1 <- margins.des(m1,expand.grid(parrole=1,woman=1))
margins.dat(m1,des1,rounded=5)
des3 <- margins.des(m1,expand.grid(age=seq(20,75,5),parrole=c(0,1)))
a<- margins.dat(m1,des3,rounded=5)
a

---
title: "margins.dat.clogit"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the margins.dat.clogit function.
vignette: >
  %\VignetteIndexEntry{margins.dat.clogit}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Computes predicted probabilities for conditional and rank-order/exploded logistic regression models. Inference is based upon simulation techniques. Alternatively, bootstrapping is an option for conditional logistic regression models.


```{r}
library(catregs)
library(Epi)
data("LF06travel")
m1 <- clogistic(choice ~ train + bus + time  + invc, strata=id, data=LF06travel)
design <- data.frame(train=c(0,0,1),bus=c(0,1,0),time=200,invc=20)
design
margins.dat.clogit(m1,design)

```

---
title: "diagn"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the diagn function.
vignette: >
  %\VignetteIndexEntry{diagn}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

This function computes case-level diagnostics for generalized linear models. Conditional on model type, the function computes the most relevant diagnostics (circa 2024) and returns them as a data.frame object. 

For example:
```{r}
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
head(diagn(m1))
```

---
title: "margins.des"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the margins.des function.
vignette: >
  %\VignetteIndexEntry{margins.des}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

We often illustrate the implications of a regression model by graphing marginal means or fitted values from the model by levels of one or more predictors. Such graphs illustrate how the response changes as a function of predictors. This is a particularly useful strategy for explaining statistical interactions between independent variables. 

Doing so entails creating a design matrix of response values for the independent variables. Software packages generally automate this process. Within R, the emmeans package allows you to set independent variable values, and then it has a few options for how to deal with variables that are not explicitly specified (e.g., proportional weighting, etc.). Stata does effectively the same thing, allowing users to specify values for some variables and imputing values for other variables. In either case, this process is automated, and just fitted values are reported. That is, users generally do not even look at the design matrix. 

In the context of catregs, working with the design matrix may be necessary. Multi-category predictors and mathematically linked variables (interaction terms, squared-terms) may need to be adjusted (also true with emmeans). As such, it is good practice to examine the design matrix to ensure that the underlying data depict the patterns you want to illustrate. This is often overlooked. 

margins.des makes the generation of such design matrices straightforward. Given a model object, margins.des pulls out the underlying data and sets all independent variables to their means. Users can alter this in two ways. First, users can set levels of independent variables. If multiple variables are listed, their categories are factorially crossed in the design matrix. Second, users can exclude variables from the design matrix. This is intended to be used with factor variables. Users exclude factor variables from the design matrix in this step, and then factors are proportionally weighted in the margins.dat function. 


The first application of margins.des creates a design matrix varying the states of "woman." It sets all covariates to their means by default. If we wanted to vary "woman" but look at only parents, we would use the second margins.des command.
```{r}
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
margins.des(mod=m1,ivs=expand.grid(woman=c(0,1)))
margins.des(mod=m1,ivs=expand.grid(woman=c(0,1),parrole=1))
```

Generally when illustrating statistical interaction effects we want to generate fitted values at factorially-crossed levels of independent variables. We use the base R function "expand.grid" inside the "ivs" option to do this. Below is an example for a 2x2 interaction:

```{r}
margins.des(mod=m1,ivs=expand.grid(woman=c(0,1),parrole=c(0,1)))

```

And here is a more complicated design matrix with a continuous variable. 
```{r}
margins.des(mod=m1,ivs=expand.grid(woman=c(0,1),income=seq(0,150,10)))
```


In practice, define an object using margins.des. Examine it and alter it as needed. Then generate fitted values using margins.dat.

---
title: "second.diff.fitted"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the second.diff.fitted function.
vignette: >
  %\VignetteIndexEntry{second.diff.fitted}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Computes the second difference in fitted values from an estimated regression model. Inference in supported via the delta method or bootstrapping.


For example:
```{r}
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
des2<-margins.des(m1,expand.grid(woman=c(0,1),parrole=c(0,1)))
des2
second.diff.fitted(m1,des2,compare=c(4,2,3,1),rounded=5) # [Pr(Drink | Mothers) - Pr(Drink | Childless Women)] - [Pr(Drink | Fathers) - Pr(Drink | Childless Men)]
# Note that this is reported as the "Second Difference" in Table 3 of Mize (2019: 104, "Best Practices for Estimating, Interpreting, and Presenting Nonlinear Interaction Effect. Sociological Science. 6(4): 81-117.")
```

---
title: "rubins.rule"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the rubins.rule function.
vignette: >
  %\VignetteIndexEntry{rubins.rule}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

The function aggregates multiple standard errors using Rubin's (2004) rule. 
Rubin, Donald B. 2004. Multiple Imputation for Nonresponse in Surveys. Vol. 81. John Wiley & Sons.

---
title: "margins.dat"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the margins.dat function.
vignette: >
  %\VignetteIndexEntry{margins.dat}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Given a design matrix, as generated by the design.des function, the design.dat function appends (1) fitted values on the response scale ("fitted"), (2) the delta method standard error for the fitted value ("se"), (3) the lower limit of a confidence interval around the fitted value ("ll"), and the upper limit of a confidence interval around the fitted value ("ul").

For example:
```{r}
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
des2<-margins.des(m1,expand.grid(woman=c(0,1),parrole=c(0,1)))
margins.dat(m1,des2,rounded=5)
des1 <- margins.des(m1,expand.grid(parrole=1,woman=1))
margins.dat(m1,des1,rounded=5)
des3 <- margins.des(m1,expand.grid(age=seq(20,75,5),parrole=c(0,1)))
a<- margins.dat(m1,des3,rounded=5)
a
```

---
title: "compare.margins"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the compare.margins function.
vignette: >
  %\VignetteIndexEntry{compare.margins}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Compares two marginal effects (MEMs or AMEs). Estimate of uncertainty is from a simulated draw from a normal distribution.

For example:
```{r}
library(catregs)
data("essUK")
m1 <- glm(safe ~ religious + minority*female + age,data=essUK,family="binomial")
des<-margins.des(m1,expand.grid(minority=c(0,1),female=c(0,1)))
des
ma1 <- suppressWarnings(as.data.frame(marginaleffects::avg_slopes(m1,
                                                                         variables="female",newdata=marginaleffects::datagrid(minority=0,
                                                                                                                              religious=3.6024,age=53.146))))
ma2 <- suppressWarnings(as.data.frame(marginaleffects::avg_slopes(m1,
                                                                  variables="female",newdata=marginaleffects::datagrid(minority=1,
                                                                                                                       religious=3.6024,age=53.146))))
cames <- rbind(ma2,ma1)
compare.margins(margins=cames$estimate,margins.ses=cames$std.error)
```

---
title: "count.fit"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the count.fit function.
vignette: >
  %\VignetteIndexEntry{count.fit}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

This function compares four models for count responses, namely Poisson regression, negative binomial regression, zero-inflated Poisson regression, and zero-inflated negative binomial regression. To do so, it takes a Poisson regression model object (as specified via glm), and the range on the count outcome. This function mimics the countfit function developed in Long and Freese (2006).

For example:
```{r}
library(catregs)
data("LF06art")
p1 <- glm(art ~ fem + mar + kid5 + phd + ment , family = "poisson", data = LF06art)
table(LF06art$art)
fit<-count.fit(p1,0:19)
names(fit)
#fit$ic
#fit$pic
#fit$models
#fit$models.pic
```

---
title: "list.coef"
output: rmarkdown::html_vignette
description: >
  This vignette explains the rationale and implementation for the list.coef function.
vignette: >
  %\VignetteIndexEntry{list.coef}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Regression models for limited dependent variables are interpreted in several different ways. The estimated coefficients are often transformed before being interpreted, for example. Exponentiating logistic or count regression coefficients is common, as is converting the coefficient into percent change. The list.coef function transforms model coefficients into these additional quantities. It also reports confidence intervals for exponentiated coefficients. Users may specify the \# of decimal places to report and the alpha level. For example:

```{r}
library(catregs)
data("Mize19AH")
m1 <- glm(alcB ~woman*parrole + age + race2 + race3 + race4 + income + ed1 + ed2 + ed3 + ed4,family="binomial",data=Mize19AH)
list.coef(m1)
```

In the above, b refers to the original model coefficient, S.E. to the estimated model coefficient's standard error, Z is the z-statistic (b/se(b)), LL.CI is the lower limit of the confidence interval around the model coefficient, UL.CI is the upper limit of the confidence interval around the model coefficient, p-val is the p-value associated with the z-statistic, exp.b is the exponentiated model coefficient, LL.CI.for.exp.b is the lower limit of the confidence interval around the exponentiated model coefficient, UL.CI.for.exp.b is the upper limit of the confidence interval around the exponentiated model coefficient, Percent is the % change interpretation of the coefficient, i.e., 100\*(1-(exp(b))), and CI is the amount of confidence in the confidence interval.
